#pragma once

#include <cstdint>
#include <sys/types.h>

// Read External Memory
void memory_writer(uint32_t guest_addr, void *data, uint32_t size);
void init_memory(pid_t guest_pid);

// Shared Memory
void init_shared_memory_common();
void init_shared_memory_guest();
void init_shared_memory_host();
extern unsigned char *shared_memory_host_only;
void free_shared_memory();